/*
     Object Oriented Programming using C++,
     Solution Manual and Applied Examples.
	    written by Dr. Farschad Torabi
     K. N. Toosi University of Technology  
	           September, 2013

                 Program 12.1
*/

#include<string>
#include<iostream>
using namespace std;

class Array
{
public:
  int ni;
  double * e;

  void Allocate(int i)
  {
    e = new double[i];
    ni = i;
  }
  void DeAllocate()
  {
    delete[] e;
    ni = 0;
  }
  virtual int length(){return ni;}
  void set(int i, double value){e[i]=value;}
  double get(int i){return e[i];}
};

class Array2d : public Array
{
public:
  int nj;

  void Allocate(int i, int j)
  {
    e = new double[i*j];
    ni = i;
    nj = j;
  }
  void DeAllocate()
  {
    delete[] e;
    ni = 0;
  }
  virtual int length(){return ni*nj;}
  int get_nRows(){return ni;}
  int get_nCols(){return nj;}
  void set(int i, int j, double value){e[i*nj + j]=value;}
  double get(int i, int j){return e[i*nj + j];}  
};

int main()
{
  Array2d X;
  X.Allocate(2, 3);
  X.set(0,0,0);  X.set(0,1, 1);  X.set(0,2, 4);
  X.set(1,0,9);  X.set(1,1,16);  X.set(1,2,25);

  return 0;
}