/*
     Object Oriented Programming using C++,
     Solution Manual and Applied Examples.
	    written by Dr. Farschad Torabi
     K. N. Toosi University of Technology  
	           September, 2013

                 Program 12.2
*/

#include<string>
#include<iostream>
#include<fstream>
using namespace std;


class Array
{
public:
  int n;
  double * e;

  void Allocate(int i)
  {
    e = new double[i];
    n = i;
  }
  void DeAllocate()
  {
    delete[] e;
    n = 0;
  }
  int length(){return n;}
  void set(int i, double value){e[i]=value;}
  double get(int i){return e[i];}
};

class Personnel
{
public:
  //--- Attributes 
  string Name, Family;
  int ID, nCourse;
  Array Grades;

  //--- Methods 
  void set_Name(string str){Name = str;}
  void set_Family(string str){Family = str;}
  void set_ID(int stid){ID = stid;}
  void set_Grade(int i, double stgrd){Grades.e[i] = stgrd;}
  virtual void GradeReport(ostream &f)  {  }
  virtual void Category(ostream &f)  {  }
  void Report()
  {
    cout << "------------------------------"<<endl;
    cout << "   Personnel Category : ";   Category(cout); 
    cout << "                 Name : " << Name  << endl;
    cout << "               Family : " << Family<< endl;
    cout << "                   ID : " << ID    << endl;
    cout << "               Grades : " ;
    int i;
    for(i=0;i<Grades.n;i++)
      cout << Grades.e[i] << ", ";
    cout << endl;
    GradeReport(cout);
    cout << "------------------------------"<<endl;
  }
  void Report(string fileName)
  {
    ofstream fout(fileName.c_str());
    fout << "------------------------------"<<endl;
    fout << "   Personnel Category : ";   Category(fout); 
    fout << "                 Name : " << Name  << endl;
    fout << "               Family : " << Family<< endl;
    fout << "                   ID : " << ID    << endl;
    fout << "               Grades : " ;
    int i;
    for(i=0;i<Grades.n;i++)
      fout << Grades.e[i] << ", ";
    fout << endl;
    GradeReport(fout);
    fout << "------------------------------"<<endl;
    fout.close();
  }

};

class Student : public Personnel
{
public:
  double GPA;
  int nFailed;

  void checkFailed()
  {
    int i = 0;
    nFailed = 0;
    for (i=0;i<Grades.length();i++)
      if(Grades.e[i]<10) nFailed++;
  }
  double gpa()
  {
    GPA = 0.0;
    int i = 0;
    for (i=0;i<Grades.length();i++)
      GPA += Grades.e[i];
    GPA /= Grades.length();
    return GPA;
  }
  virtual void GradeReport(ostream &f)  
  { 
    checkFailed();
    f << "                  GPA : " << gpa() << endl;
    f << " No of Failed Courses : " << nFailed <<endl; 
  }

  virtual void Category(ostream &f)  { f<<"Students"<<endl; }

};
class Professor : public Personnel
{

 // virtual void GradeReport(ostream &f)  { }
  virtual void Category(ostream &f)  { f<<"Professors"<<endl; }

};

int main()
{
  Student st;
  Professor prof;
  st.set_Name("Farschad");
  st.set_Family("Torabi");
  st.set_ID(728841);
  st.Grades.Allocate(3);
  st.set_Grade(0,15.75);
  st.set_Grade(1,13.00);
  st.set_Grade(2,17.50);

  prof.set_Name("Ali");
  prof.set_Family("Rahmani");
  prof.set_ID(872078);
  prof.Grades.Allocate(4);
  prof.set_Grade(0,10.15);
  prof.set_Grade(1,18.20);
  prof.set_Grade(2,16.75);
  prof.set_Grade(3,14.75);

  st.Report();
  prof.Report("Results.txt");

  cin>>st.ID;
  return 0;
}
